#ifndef __SVT_H__
#define __SVT_H__

#include "FastFit.h"
#include "VcfRecord.h"
#include "VcfFileReader.h"
#include "VcfHeader.h"
#include <Eigen/Eigenvalues>
#include "Random.h"

class SVT
{
   public:
      SVT() {};
      virtual ~SVT() {};
      static bool LRT;
      static bool SCORE;
      static bool WALD;
      static int Xstart;
      static int Xend;
      static bool dosage;
      static bool genoFromPed;
      static bool genoFromVCF;
      static bool FounderFreq;
      static int nFounder;
      static String xLabel;
      static int maleLabel;
      static int femaleLabel;
      static int simulate;
      static int seed;

      //this is the total number of genes
      int geneCount, numFounders;
      StringArray SNPNameList, geneNamesAll;

      void GetAllGenenamesVCF();

      //this is the name of the annotated vcf file.
      static String geneMapfile;

      //this the vector of genotype for single variant test.
      VcfFileReader reader;
      VcfHeader header;
      VcfRecord record;
      Eigen::VectorXf genotype;
      Vector founderAF,allAF;
double miss;

      //Random rand(seed);

      //these are for outputs
      double founderMaf, markerMaf,callRate,hwe_pvalue;
      String chr,refAllele,rareAllele;
      int alleleCount,pos;
      int het,hom1,hom2;
      double mac;

      bool GetGenotypeVector(FastTransform & trans, Pedigree & ped,int markerid);
      bool GetGenotypeVectorPED(FastTransform & trans, Pedigree & ped,int markerid);
      void Run(Pedigree & ped, FastTransform & trans, FastFit & engine,String & traitName,FILE * log);	
      void PrintHeader(FILE * output,FastFit & engine,FastTransform & trans);
      bool GetGenotypeVectorVCFDosage(FastTransform & trans, Pedigree & ped);
      bool GetGenotypeVectorVCF(FastTransform & trans, Pedigree & ped);
      double EvaluatePermutation(Pedigree & ped, FastTransform & trans, double & founderFreq, double & chisq, Eigen::VectorXf & residuals, Vector & sigma2, int & m);
};

#endif
